$TITLE(I2C_Test_Device command)
;*==========================================================*
;*                                                          *
;*         SOURCE FILE : I2C_TDEV.ASM                       *
;*         PACKAGE     : I2C                                *
;*                                                          *
;*==========================================================*
$DEBUG


;*==========================================================*
;*    I N C L U D E S                                       *
;*==========================================================*
$NOLIST
$INCLUDE(I2C_DATA.GLO)
$LIST


;*==========================================================*
;*    G L O B A L   R E F E R E N C E S                     *
;*==========================================================*
    EXTRN CODE(I2C_MESS_HAND)


;*==========================================================*
;*    G L O B A L   F U N C T I O N   D E F I N I T I O N S *
;*==========================================================*
    PUBLIC _I2C_TEST_DEVICE


;*==========================================================*
;*    L O C A L   S Y M B O L   D E C L A R A T I O N S     *
;*==========================================================*
    TEST_DEVICE_MASK  EQU 80H
                    ;REP_STRT_BLK1  = 0    (NO)
                    ;RWN_BLK1       = 0    (WRITE)
                    ;ADDR2          = 0    (NO)
                    ;ADDR2_SUB      = 0    (--)
                    ;BLOCK2         = 0    (NO)
                    ;RWN_BLK2       = 0    (--)
                    ;REP_STRT_BLK2  = 0    (--)
                    ;T_DEVICE       = 1    (--)


;*==========================================================*
;*    C O D E   S E G M E N T                               *
;*==========================================================*
    I2C_DRIVER SEGMENT CODE
    RSEG I2C_DRIVER


;*MPF:::I2C::I2C_TDEV.ASM:I2C_TEST_DEVICE===================*
;*                                                          *
;* FUNCTION NAME:      I2C_TEST_DEVICE                      *
;* PACKAGE:            I2C                                  *
;* DESCRIPTION:                                             *
;*   Address a slave , if ack received slave was present    *
;*                                                          *
;* PROTOCOL:                                                *
;*   <S><SLV_ADDR><W><A><P>                                 *
;*                                                          *
;* INPUT: Message control byte I2C_CTRL (bit addressable)   *
;*        Message control block I2C_MCB, containing:        *
;*          I2C_ADDR1       (slave address)                 *
;*                                                          *
;* OUTPUT: I2C_ERROR byte  (bit addressable)                *
;*                                                          *
;*EMP=======================================================*

_I2C_TEST_DEVICE:
        MOV     I2C_CTRL,#TEST_DEVICE_MASK
        AJMP    I2C_MESS_HAND

        END
