/******************************************************************
  Program do obsugi funkcji interfejsu sprztowego I2C PCF8584.
  Zbir nagwkowy zawierajcy szereg oglnie dostpnych deklaracji
  staych i funkcji. Na podstawie AN95068 firmy Philips

  Raisonance RC-51
 ******************************************************************/


#define null	((void *)0)						//wskanik null

typedef struct
{
	unsigned char address;						//adres urzdzenia slave, odbiorcy transmisji
	unsigned char nrBytes;						//liczba bajtw w buforze
	unsigned char *buf;							//wskanik do bufora aplikacji
} I2C_MESSAGE;


typedef struct
{
	unsigned char nrMessages;					//liczba komunikatw w pojedynczej transmisji
	I2C_MESSAGE **p_message;					//wskanik do komunikatu
} I2C_TRANSFER;


#define	false		0								//niektre stae uywane w programie
#define	true		1
#define	I2C_WR	0x00
#define	I2C_RD	0x01

/**** Kody komunikatw o bdach ****/
#define I2C_OK							0x00		//koniec transmisji,bez bdw
#define I2C_BUSY						0x01		//magistrala I2C zajta
#define I2C_ERR 						0x02		//oglny kod bdu
#define I2C_NO_DATA					0x03		//brak danych w bloku
#define I2C_NACK_ON_DATA			0x04		//brak potwierdzenia odbioru danych od urzdzenia slave
#define I2C_NACK_ON_ADDRESS		0x05		//brak potwierdzenia odbioru adresu od urzdzenia slave
#define I2C_DEVICE_NOT_PRESENT	0x06		//brak urzdzenia
#define I2C_ARBITRATION_LOST		0x07		//przegrana w arbitrau
#define I2C_TIME_OUT					0x08		//przekroczenie limitu czasu operacji
#define I2C_SLAVE_ERROR				0x09		//bd trybu slave
#define I2C_INIT_ERROR				0x0A		//bd inicjalizacji

/* prototypy funkcji interfejsu */
extern void I2C_InitializeMaster(unsigned char speed);
extern void I2C_InitializeSlave(unsigned char slv, unsigned char *buf, unsigned char size, unsigned char speed);
extern void I2C_InstallInterrupt(unsigned char vector);
extern void I2C_Interrupt(void) interrupt 0;
extern void I2C_Write(I2C_MESSAGE *msg);
extern void I2C_WriteRepWrite(I2C_MESSAGE *msg1, I2C_MESSAGE *msg2);
extern void I2C_WriteRepRead(I2C_MESSAGE *msg1, I2C_MESSAGE *msg2);
extern void I2C_Read(I2C_MESSAGE *msg);
extern void I2C_ReadRepRead(I2C_MESSAGE *msg1, I2C_MESSAGE *msg2);
extern void I2C_ReadRepWrite (I2C_MESSAGE *msg1, I2C_MESSAGE *msg2);
 
