;typ pamici    93C46	   93C56	   93C57	   93C66
;---------------------------------------------------------------
;bity danych:	8	16	8	16	8	16	8	16
;bity adresu:	7	6	9	8	8	7	9	8

;aby wybra dugo sowa adresowego, naley ustawi warto staej NADDR
NADDR		EQU	7		; np. AT93C46, dane 8-bitowe 
;NADDR	EQU	6			; np. AT93C46, dane 16-bitowe 

;rozmiar danych
size		EQU	f0		; 0 = dane 8-bitowe, 1 = dane 16-bitowe

;definicje zmiennych wykorzystujca rejestry mikrokontrolera
data_lo		EQU	r0		;rejestr danych, modszy bajt
data_hi		EQU	r1		;rejestr danych, starszy bajt
addr_lo		EQU	r2		;rejestr adresu, modszy bajt 
addr_hi		EQU	r3		;rejestr adresu, starszy bajt

;poczenia mikrokontrolera z wyprowadzeniami AT93Cxx
CS		BIT	P1.2		; AT93Cxx CS
SK		BIT	P1.3		;         SK
DI		BIT	P1.4		;         DI
DO		BIT	P1.5		;         DO


		DSEG AT 20H

		ORG	20H		;pooenie stosu
stack:	DS	20H			;rozmiar stosu

		CSEG

		ORG	0000H		;wektor przerwania po reset
		jmp	on_reset


;*********************************************************
;pocztek programu gwnego
;*********************************************************
		ORG	0080H
		USING	0		;wybr banku rejestrw numer 0
on_reset:
		mov	sp, #(stack-1)	;ustalenie rozmiaru stosu

;inicjowanie linii interfejsu uWire
		clr	CS
		clr	SK
		setb	DI
		setb	DO 

;inicjowanie wskanika rozmiaru sowa danych
		clr	size		;dane 8-bitowe
;		setb	size		;dane 16-bitowe

;*********************************************************
;przykady wywoa funkcji
;*********************************************************
; funkcja Read (bajt gdy SIZE/ORG=0, word gdy SIZE/ORG=1).
		mov	addr_lo, #0		;ustalenie adresu
		call	read			;odczyt

;funkcja Write  zapis bajtu (SIZE/ORG=0).
		mov	addr_lo, #7fh		;ustalenie adresu bajtu
		mov	data_lo, #55h		;dane
		call	write			;sprawd flag CY po powrocie

;funkcja Write  zapis sowa 16-bitowego (SIZE/ORG=1).
		mov	addr_lo, #3fh		;ustalenie adresu sowa
		mov	data_lo, #55h		;mniej znaczcy bajt danych
		mov	data_hi, #0aah		;bardziej znaczcy bajt danych
		call	write			;sprawd CY po powrocie

;wypenienie obszaru sta wartoci o rozmiarze 1-go bajtu (SIZE/ORG=0).
		mov	data_lo, #55h		;bajt danych
		call	wral			;sprawd CY po powrocie

;wypenienie obszaru sta wartoci o rozmiarze 2-bajtw (SIZE/ORG=1).
		mov	data_lo, #55h		;dane,lsb
		mov	data_hi, #0aah		;dane,msb
		call	wral			;sprawd CY po powrocie


;kasowanie danych pod wskazanym adresem (1-bajtowych, gdy SIZE/ORG=0, 
;2-bajtowych, gdy SIZE/ORG=1).
		mov	addr_lo, #0		;ustalenie adresu
		call	erase			;sprawd CY po powrocie

;kasowanie caoci danych w pamici
		call	eral			;sprawd CY po powrocie

;zezwolenie na zapis
		call	ewen

;zabronienie zapisu
		call	ewds


;odczyt bajtu lub sowa spod adresu wskazywanego przez ADDR_HI:ADDR_LO
;dane zwracane w DATA_HI:DATA_LO, modyfikowany s rejestry B i DPTR
read:		setb	CS			;ustawienie sygnau CS
		mov	dpl, #110b		;wyprowadzenie bitu startu 1b i kodu
		mov	b, #3			;operacji 10b
		call	outdata
						;wysanie adresu
		mov	dpl, addr_lo		;lsb
		mov	dph, addr_hi		;msb
		mov	b, #NADDR		;inicjowanie licznika bitw
		call	outdata
		call	indata			;pobierz zwracane dane
		clr	CS			;zeruj CS
		ret


;zapis bajtu lub sowa pod adres wskazywany przez ADDR_HI:ADDR_LO
;dane w DATA_HI:DATA_LO, modyfikowany s rejestry B i DPTR
;przed wywoaniem nie jest wymagane kasowanie komrki pamici, do ktrej
;wykonywana bdzie operacja zapisu
write:		setb	CS			;ustawienie sygnau CS
		mov	dpl, #101b		;wyprowadzenie bitu startu 1b i kodu
		mov	b, #3			;operacji 01b
		call	outdata
						;wysanie adresu
		mov	dpl,addr_lo		;lsb
		mov	dph,addr_hi		;msb
		mov	b, #NADDR		;inicjowanie licznika bitw
		call	outdata
						;wyprowadzenie danych, najpierw MSB
						;liczba bajtw zaley od wart. size
		mov	dpl, data_lo
		jb	size, ee61
		mov	b, #8

		jmp	ee62
ee61:
		mov	dph, data_hi
		mov	b, #16
ee62:
		call	outdata
		clr	CS			;kasowanie linii CS
;sprawdzenie statusu pamici
		call	status			;status zwracany w CY
		ret


;wypenienie pamici sta, staa w DATA_HI:DATA_LO.
;ustawia flag CY w celu oznaczenia bdu operacji, niszczy B i DPTR
wral:		setb	CS			;ustawienie sygnau CS
						;wyprowadzenie bitu startu oraz kodw
						;operacji 00b i 01b poprzedzan przez
						;waciw dla modelu pamici liczb
						;niezdefiniowanych bitw
		mov	dptr, #(10001b SHL (NADDR-2))
		mov	b, #(NADDR+3)
		call	outdata
		mov	dpl, data_lo		;wyprowadzanie danych, lsb
		jb	size, ee71
		mov	b, #8
		jmp	ee72
ee71:
		mov	dph, data_hi
		mov	b, #16
ee72:
		call	outdata
		clr	CS			;kasowanie CS

		call	status			;testowanie statusu operacji
		ret


;kasowanie bajtu (sowa) pod wskazanym w ADDR_HI:ADDR_LO adresem
;zwraca CY jako wskanik bdu operacji, niszczy B i DPTR
erase:	setb	CS
		mov	dptr, #111b		;wyprowadzenie bitu startu 1b i kodu
		mov	b, #3			;operacji 11b
		call	outdata
		mov	dpl, addr_lo		;wyprowadzenie adresu
		mov	dph, addr_hi
		mov	b, #NADDR		;licznik bitw adresu
		call	outdata
		clr	CS
		call	status			;badanie statusu operacji
		ret


;kasowanie zawartoci pamici
;zwraca CY jako wskanik bdu operacji, niszczy B i DPTR

eral:		setb	CS 
;wyprowadzenie bitu startu 1b i kodu
;operacji 00b
		mov	dptr, #(10010b SHL (NADDR-2))
		mov	b, #(NADDR+3)
		call	outdata
		clr	CS
		call	status
		ret


;zezwolenie na zapis / kasowanie, niszczy B i DPTR, nie ustawia CY
ewen:
		setb	CS 
						;wyprowadzenie bitu startu 1b i kodw
;operacji 00b i 11b.
		mov	dptr, #(10011b SHL (NADDR-2))
		mov	b, #(NADDR+3)
		call	outdata
		clr	CS 
		ret


;zabronienie zapisu / kasowania danych, niszczy B i DPTR, nie ustawia CY
ewds:		setb	CS
						;wyprowadzenie bitu startu 1b i kodw 
;operacji 00b i 00b.
		mov	dptr, #(10000b SHL (NADDR-2))
		mov	b, #(NADDR+3)
		call	outdata
		clr	CS 
		ret


;odczyt statusu urzdzenia, CY = 0 gdy gotowe do pracy, 1 w innym przypadku
status:	push	b
		setb	DO			;ustawienie 1 na DO
		setb	CS			;ustawienie CS
		mov	b, #220			; 220 * 50 uS = 11 ms
						;opnienie 50 us
ee40:
		push	b			;2 us
		mov	b, #22			;2 us
		djnz	b, $			;2 us * 22
		pop	b			;2 us
		jb	DO, ee41		;skok, jeli DO jest w stanie wysokim
		djnz	b, ee40			;powtrzenie przebiegu ptli
		setb	c			;ustawienie wskanika bdu
		jmp	ee42			;powrt
ee41:
		clr	c			;kasowanie wskanika bdu
ee42:
		clr	CS			;kasowanie sygnau wyboru
		pop	b
		ret


;odczyt danych z AT93Cxx, dane zwracane w DATA_HI:DATA_LO
indata:		setb	DO 
		call	shin			;odczyt pierwszego bajtu danych
		jnb	size, ee21		;skok,jeli dane maj rozmiar 1-bajtu
		mov	data_hi, a		;zapamitaj msb
		call	shin			;odczyt drugiego bajtu (gdy konieczny)
ee21:
		mov	data_lo, a		;zapamitaj lsb
		ret


;wprowadza 8-bitw z wejcia szeregowego DO, bajt zwracany w A
shin:		push	b
		clr	SK			;zerowanie linii zegara
		mov	b, #8 
ee30:
		setb	SK			;ustaw lini zegara
		nop				;opnienie min. 1us
		mov	c, DO			;odczyt sygnau wejciowego
		rlc	a 
		clr	SK			;zerowanie linii zegara
		djnz	b, ee30			;nastpny bit
		pop	b
		ret


;wyprowadzenie danych do AT93Cxx, niszczy A i DPTR
outdata:	push	b
		mov	a, b			;pobierz licznik bitw
		clr	c			;porwnaj z #8
		subb	a, #8
		jc	ee6			;skocz, gdy licznik mniejszy ni #8
		jz	ee5			;skocz, gdy licznik rwny #8

		mov	b, a			;zapamitaj licznik bitw po operacji
		clr	c			;porwnaj z #8
		subb	a, #8
		jc	ee2			;skocz, gdy licznik mniejszy ni #8
		jnz	ee9			;skocz, gdy licznik rwny #8
						;licznik jest rwny #8
		mov	a, dph
		jmp	ee4
						;licznik mniejszy ni #8
ee2:
		push	b			;zapamitaj licznik bitw
		mov	a, dph			;pobierz dane
ee3:
		rr	a			;przesu w bity w prawo
		djnz	b, ee3
		pop	b			;odtwrz licznik bitw
ee4:
		call	shout
						;by starszy bajt, wylij modszy
		mov	b, #8
						;licznik bitw jest rwny #8
ee5:
		mov	a, dpl
		jmp	ee8
						;licznik bitw mniejszy ni #8
ee6:
		push	b			;zapamitaj licznik
		mov	a, dpl			;pobierz dane
ee7:
		rr	a			;przesu w prawo
		djnz	b, ee7
		pop	b			;odtwrz licznik
ee8:
		call	shout
ee9:
		setb	DO			;zwolnij DO

		pop	b
		ret


;wyprowadza bajt do AT93Cxx, niszczy A i B
shout:		clr	SK			;kasowanie linii zegara
		rlc	a			;wprowadzenie bitu do CY
		mov	DI, c	 		;ustawienie linii danych
		nop				;opnienie minimum 400ns
		setb	SK			;ustawienie linii zegara
		djnz	b, shout		;nastpny bit
		clr	SK			;zwolnienie linii zegara
		ret

END
